//+------------------------------------------------------------------+
//|                                                       gerain.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters

extern double TakeProfit = 25;
extern double Lots = 0.1;
extern double TrailingStop = 25;
//----
int TickNum = 0;
int iLastError = 0;
int OpenOrder = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerM1  = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerM5  = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerM15 = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerM30 = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerH1  = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerH4  = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerD1  = 0;  // 0 -  , 1 - buy,  2 - sell
int BollingerW1  = 0;  // 0 -  , 1 - buy,  2 - sell


double BollingerUpM1,  BollingerDownM1 ; //    
double BollingerUpM5,  BollingerDownM5 ;
double BollingerUpM15, BollingerDownM15 ;
double BollingerUpM30, BollingerDownM30 ;
double BollingerUpH1,  BollingerDownH1 ;
double BollingerUpH4,  BollingerDownH4 ;
double BollingerUpD1,  BollingerDownD1 ;
double BollingerUpW1,  BollingerDownW1 ;

double BollingerDownPreviousM1,  BollingerUpPreviousM1;
double BollingerDownPreviousM5,  BollingerUpPreviousM5;
double BollingerDownPreviousM15, BollingerUpPreviousM15;
double BollingerDownPreviousM30, BollingerUpPreviousM30;
double BollingerDownPreviousH1,  BollingerUpPreviousH1;
double BollingerDownPreviousH4,  BollingerUpPreviousH4;
double BollingerDownPreviousD1,  BollingerUpPreviousD1;
double BollingerDownPreviousW1,  BollingerUpPreviousW1;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{ int cnt=0, ticket, total;
 
//  
//     
         // 
   BollingerDownM1           =iBands(NULL,PERIOD_M1,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpM1             =iBands(NULL,PERIOD_M1,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousM1   =iBands(NULL,PERIOD_M1,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousM1     =iBands(NULL,PERIOD_M1,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
         //5 
   BollingerDownM5           =iBands(NULL,PERIOD_M5,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpM5             =iBands(NULL,PERIOD_M5,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousM5   =iBands(NULL,PERIOD_M5,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousM5     =iBands(NULL,PERIOD_M5,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
         //15 
   BollingerDownM15          =iBands(NULL,PERIOD_M15,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpM15            =iBands(NULL,PERIOD_M15,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousM15  =iBands(NULL,PERIOD_M15,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousM15    =iBands(NULL,PERIOD_M15,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
         //
   BollingerDownM30          =iBands(NULL,PERIOD_M30,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpM30            =iBands(NULL,PERIOD_M30,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousM30  =iBands(NULL,PERIOD_M30,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousM30    =iBands(NULL,PERIOD_M30,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
        //
   BollingerDownH1           =iBands(NULL,PERIOD_H1,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpH1             =iBands(NULL,PERIOD_H1,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousH1   =iBands(NULL,PERIOD_H1,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousH1     =iBands(NULL,PERIOD_H1,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
        //4 
   BollingerDownH4           =iBands(NULL,PERIOD_H4,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpH4             =iBands(NULL,PERIOD_H4,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousH4   =iBands(NULL,PERIOD_H4,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousH4     =iBands(NULL,PERIOD_H4,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
        // 
   BollingerDownD1           =iBands(NULL,PERIOD_D1,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpD1             =iBands(NULL,PERIOD_D1,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousD1   =iBands(NULL,PERIOD_D1,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousD1     =iBands(NULL,PERIOD_D1,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   

  
       // 
   BollingerDownW1           =iBands(NULL,PERIOD_W1,20,2,0,PRICE_CLOSE,MODE_LOWER,0);   // 
   BollingerUpW1             =iBands(NULL,PERIOD_W1,20,2,0,PRICE_CLOSE,MODE_UPPER,0);   // 
   BollingerDownPreviousW1   =iBands(NULL,PERIOD_W1,20,2,0,PRICE_CLOSE,MODE_LOWER,1);   //   
   BollingerUpPreviousW1     =iBands(NULL,PERIOD_W1,20,2,0,PRICE_CLOSE,MODE_UPPER,1);   //   
 
   if (BollingerDownM1 >= Bid && BollingerDownM1-BollingerDownPreviousM1 > 0 )   BollingerM1 = 1;    // BollingerM1 = Buy
   if (BollingerUpM1   <= Ask && BollingerUpM1 - BollingerUpPreviousM1   < 0 )   BollingerM1 = 2;    // BollingerM1 = Sell
   else BollingerM1 = 0 ;                                                                             // BollingerM1 = Hold

   if (BollingerDownM5 >= Bid && BollingerDownM5-BollingerDownPreviousM5 > 0 )   BollingerM5 = 1;    // BollingerM5 = Buy
   if (BollingerUpM5   <= Ask && BollingerUpM5 - BollingerUpPreviousM5   < 0 )   BollingerM5 = 2;    // BollingerM5 = Sell
   else BollingerM5 = 0 ; 

   if (BollingerDownM15 >= Bid && BollingerDownM15-BollingerDownPreviousM15 > 0 )   BollingerM15 = 1;    // BollingerM15 = Buy
   if (BollingerUpM15   <= Ask && BollingerUpM15 - BollingerUpPreviousM15   < 0 )   BollingerM15 = 2;    // BollingerM15 = Sell
   else BollingerM15 = 0 ; 

   if (BollingerDownM30 >= Bid && BollingerDownM30-BollingerDownPreviousM30 > 0 )   BollingerM30 = 1;    // BollingerM30 = Buy
   if (BollingerUpM30   <= Ask && BollingerUpM30 - BollingerUpPreviousM30   < 0 )   BollingerM30 = 2;    // BollingerM30 = Sell
   else BollingerM30 = 0 ; 

   if (BollingerDownH1 >= Bid && BollingerDownH1-BollingerDownPreviousH1 > 0 )   BollingerH1 = 1;    // BollingerH1 = Buy
   if (BollingerUpH1   <= Ask && BollingerUpH1 - BollingerUpPreviousH1   < 0 )   BollingerH1 = 2;    // BollingerH1 = Sell
   else BollingerH1 = 0 ;                                                                            // BollingerH1 = Hold

   if (BollingerDownH4 >= Bid && BollingerDownH4-BollingerDownPreviousH4 > 0 )   BollingerH4 = 1;    // BollingerH4 = Buy
   if (BollingerUpH4   <= Ask && BollingerUpH4 - BollingerUpPreviousH4   < 0 )   BollingerH4 = 2;    // BollingerH4 = Sell
   else BollingerH4 = 0 ;                                                                            // BollingerH4 = Hold

   if (BollingerDownD1 >= Bid && BollingerDownD1-BollingerDownPreviousD1 > 0 )   BollingerD1 = 1;    // BollingerD1 = Buy
   if (BollingerUpD1   <= Ask && BollingerUpD1 - BollingerUpPreviousD1   < 0 )   BollingerD1 = 2;    // BollingerD1 = Sell
   else BollingerD1 = 0 ;                                                                             // BollingerD1 = Hold

   if (BollingerDownW1 >= Bid && BollingerDownW1-BollingerDownPreviousW1 > 0 )   BollingerW1 = 1;    // BollingerW1 = Buy
   if (BollingerUpW1   <= Ask && BollingerUpW1 - BollingerUpPreviousW1   < 0 )   BollingerW1 = 2;    // BollingerW1 = Sell
   else BollingerW1 = 0 ;                                                                             // BollingerW1 = Hold
  
Comment( "1  UP  = ",BollingerUpM1,"    M1 = ",BollingerM1,"\n",
         "1 down = ",BollingerDownM1,"\n",
         "5  UP  = ",BollingerUpM5,"    M5 = ",BollingerM5,"\n",
         "5 down = ",BollingerDownM5,"\n",
         "15 UP  = ",BollingerUpM15,"   M15 = ",BollingerM15,"\n",
         "15 Down= ",BollingerDownM15,"\n",
         "30 UP  = ",BollingerUpM30,"   M30 = ",BollingerM30,"\n",
         "30 Down= ",BollingerDownM30,"\n",
         "H1  UP  = ",BollingerUpH1,"    H1 = ",BollingerH1,"\n",
         "H1  Down= ",BollingerDownH1,"\n",
         "H4  UP  = ",BollingerUpH4,"    H4 = ",BollingerH4,"\n",
         "H4  Down= ",BollingerDownH4,"\n",
         "D1  UP  = ",BollingerUpD1,"    D1 = ",BollingerD1,"\n",
         "D1  Down= ",BollingerDownD1,"\n",
         "W1  UP  = ",BollingerUpW1,"    W1 = ",BollingerW1,"\n",
         "W1  Down= ",BollingerDownW1,"\n"
         );

//   
//         
//      (Lots, StopLoss,
// TakeProfit, TrailingStop)
//      TakeProfit
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {TakeProfit=10;
      Print("TakeProfit less than 10");
      return(0);  //  TakeProfit
     }
  
      //     
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        
   /*              
      10 ,   */
       if (BollingerM5 == 1 && OrdersTotal() == 0 && BollingerUpM5-BollingerDownM5 >=0.0010) 
        {   
          TickNum = OrderSend(Symbol(),OP_BUY,Lots,Ask,0,Bid-TrailingStop*Point,Ask+Point*TakeProfit,"My order #",16385,0,Green); //     0,1 , stop lose=25  take profit=0
          OpenOrder=1;  //1
            
        } 
  /*              
      10 ,   */      
       if (BollingerM5 == 2 && OrdersTotal() == 0 && BollingerUpM5-BollingerDownM5 >=0.0010)
        {  TickNum = OrderSend(Symbol(),OP_SELL,Lots,Bid,0,Ask+TrailingStop*Point,Bid-Point*TakeProfit,"My order #",16384,0,Green); //     0,1 , stop lose=25  take profit=0
          OpenOrder=2;   //2
        }        
 

 
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+